package org.openxma.dsl.reference.types.valueobject;

/**
 * Represents a custom DataType for <code>VODouble</code>.
 */
public class VODouble extends org.openxma.dsl.platform.valueobject.ValueObjectDouble {

    /**
     * Put the control and responsibility on the developer to determine the version of the
     * serialization class with which a serialized object is compatible.
     */
    private static final long serialVersionUID = 100L;

    /**
     * default ctor
     */
    public VODouble(Double pDouble) {
    	super(pDouble);
    }

    /**
     * Create a new instance of VODouble or return null depending on input.
     */
    public static VODouble newOrNull(Double pDouble) {
        if (pDouble != null) {
            return new VODouble(pDouble);
        }
        return null;
    }

    /**
     * Create a new instance of VODouble or return null depending on input.
     */
    public static VODouble newOrNull(String value) {
        if (value != null && value.length() > 0) {
            return new VODouble(Double.valueOf(value));
        }
        return null;
    }

}
