namespace org.openxma.dsl.reference.ui.browsemodes

import org.openxma.dsl.reference.*

component xma::BrowseModes style=DemoStyle {

    data Customer customer1
    data Customer customer2
    data Customer customer3

    page BrowseModesPage {

    	command load

    	eventmapping {
    		onInit -> load
    	}

		conditions {
			editMode = editModeCheckBox
		}

        content {
			vpanel {
				checkbox editModeCheckBox "Edit mode"
			}
			vpanel "Browse style: Standard" style=DefaultTabulator {
				cell {
	            	text tx1 label="Text 1" editable=editMode
	            	combo cb1 label="Combo 1" editable=editMode
	            }
            	customer1.firstName editable=editMode
            	cell {
					customer1.birthDate editable=editMode
					customer1.gender editable=editMode
				}
            }
            vpanel "Browse style: Text" style=BrowseStyleText {
				cell {
	            	text tx2 label="Text 2" editable=editMode
	            	combo cb2 label="Combo 2" editable=editMode
            	}
            	customer2.firstName editable=editMode
				cell {
					customer2.birthDate editable=editMode
					customer2.gender editable=editMode
				}
            }
            vpanel "Browse style: Label" style=BrowseStyleLabel {
            	label caption "asdf"
				cell {
		        	text tx3 label="Text 3" editable=editMode
		        	combo cb3 label="Combo 3" editable=editMode
            	}
            	customer3.firstName editable=editMode
				cell {
					customer3.birthDate editable=editMode
					customer3.gender editable=editMode
				}
            }
        }
    }
}

style DefaultTabulator {
	tabulator: 120,300,380,550
}

style BrowseStyleLabel extends DefaultTabulator {
	browse-control: label
	font: bold
	foreground-color: blue
	width: 50
}

style BrowseStyleText  {
	browse-control: text
}

style DemoStyle select label#caption* {
	font: bold
}


//stylegroup for label {
//	DemoStyle: name={ABC2}
//}