package org.openxma.dsl.reference.ui.layouting.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.enterprise.fmt.*;

/**
 * This class implements the generic client part of AbsoluteAttachment.
 * It implements the widgets and models of the page.
 *
 */
public abstract class AbsoluteAttachmentGen extends org.openxma.dsl.platform.xma.client.DslNotebookPage {
    private Locale genPageLocale = null;
    private ResourceBundle genPageMessages = null;
    Group absoluteAttachment_composite_0_0W;
    Text t1aW;
    ISimpleWMClient t1a;
    Text t1bW;
    ISimpleWMClient t1b;
    Text t1cW;
    ISimpleWMClient t1c;
    Text t1dW;
    ISimpleWMClient t1d;
    Label customer1_firstNameL;
    Text customer1_firstNameW;
    ISimpleWMClient customer1_firstName;
    Label customer1_lastNameL;
    Text customer1_lastNameW;
    ISimpleWMClient customer1_lastName;
    Group absoluteAttachment_composite_1_0W;
    Composite absoluteAttachment_composite_1_0_set0W;
    Label absoluteAttachment_composite_1_0_set0_centered;
    Text t2aW;
    ISimpleWMClient t2a;
    Composite absoluteAttachment_composite_1_0_set1W;
    Label absoluteAttachment_composite_1_0_set1_centered;
    Text t2bW;
    ISimpleWMClient t2b;
    Composite absoluteAttachment_composite_1_0_set2W;
    Label absoluteAttachment_composite_1_0_set2_centered;
    Text t2cW;
    ISimpleWMClient t2c;
    Composite absoluteAttachment_composite_1_0_set3W;
    Label absoluteAttachment_composite_1_0_set3_centered;
    Text t2dW;
    ISimpleWMClient t2d;
    Composite absoluteAttachment_composite_1_0_set4W;
    Label absoluteAttachment_composite_1_0_set4_centered;
    Label customer2_firstNameL;
    Text customer2_firstNameW;
    ISimpleWMClient customer2_firstName;
    Composite absoluteAttachment_composite_1_0_set5W;
    Label absoluteAttachment_composite_1_0_set5_centered;
    Label customer2_lastNameL;
    Text customer2_lastNameW;
    ISimpleWMClient customer2_lastName;
    Group absoluteAttachment_composite_2_0W;
    Composite absoluteAttachment_composite_2_0_set0W;
    Label absoluteAttachment_composite_2_0_set0_centered;
    Text t3aW;
    ISimpleWMClient t3a;
    Composite absoluteAttachment_composite_2_0_set1W;
    Label absoluteAttachment_composite_2_0_set1_centered;
    Text t3bW;
    ISimpleWMClient t3b;
    Composite absoluteAttachment_composite_2_0_set2W;
    Label absoluteAttachment_composite_2_0_set2_centered;
    Text t3cW;
    ISimpleWMClient t3c;
    Group absoluteAttachment_composite_3_0W;
    Composite absoluteAttachment_composite_3_0_set0W;
    Label absoluteAttachment_composite_3_0_set0_centered;
    Text t3dW;
    ISimpleWMClient t3d;
    Group absoluteAttachment_composite_4_0W;
    Composite absoluteAttachment_composite_4_0_set0W;
    Label absoluteAttachment_composite_4_0_set0_centered;
    Label customer3_firstNameL;
    Text customer3_firstNameW;
    ISimpleWMClient customer3_firstName;
    Composite absoluteAttachment_composite_4_0_set1W;
    Label absoluteAttachment_composite_4_0_set1_centered;
    Label customer3_lastNameL;
    Text customer3_lastNameW;
    ISimpleWMClient customer3_lastName;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the AbsoluteAttachmentGen.
     * @param notebook the Notebook this page belongs to.
     */
    public AbsoluteAttachmentGen(Notebook notebook) {
        super(notebook,false);
        createModels();
    }

    /*
     * returns the Locale used for this page
    */
    final protected Locale getGenPageLocale() {
        if (genPageLocale == null) {
            genPageLocale = getComponent().getContext().getLocale();
        }
        return genPageLocale;
    }

    /*
     * returns the message resource bundle used for this page
    */
    final protected ResourceBundle getGenPageMessages() {
        if (genPageMessages == null) {
            genPageMessages = ResourceBundle.getBundle("org.openxma.dsl.reference.ui.layouting.client.Layouting",getGenPageLocale());
        }
        return genPageMessages;
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        IFmt formatter;
        CompoundValidator compound;
        t1a = new SimpleWMClient((short) 0, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1a.setFmt(formatter);
        t1b = new SimpleWMClient((short) 1, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1b.setFmt(formatter);
        t1c = new SimpleWMClient((short) 2, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1c.setFmt(formatter);
        t1d = new SimpleWMClient((short) 3, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1d.setFmt(formatter);
        customer1_firstName = new SimpleWMClient((short) 4, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(25);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(25);
        compound.setFormatter(formatter);
        formatter = compound;
        customer1_firstName.setFmt(formatter);
        customer1_lastName = new SimpleWMClient((short) 5, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(50);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(50);
        compound.setFormatter(formatter);
        formatter = compound;
        customer1_lastName.setFmt(formatter);
        t2a = new SimpleWMClient((short) 6, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t2a.setFmt(formatter);
        t2b = new SimpleWMClient((short) 7, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t2b.setFmt(formatter);
        t2c = new SimpleWMClient((short) 8, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t2c.setFmt(formatter);
        t2d = new SimpleWMClient((short) 9, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t2d.setFmt(formatter);
        customer2_firstName = new SimpleWMClient((short) 10, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(25);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(25);
        compound.setFormatter(formatter);
        formatter = compound;
        customer2_firstName.setFmt(formatter);
        customer2_lastName = new SimpleWMClient((short) 11, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(50);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(50);
        compound.setFormatter(formatter);
        formatter = compound;
        customer2_lastName.setFmt(formatter);
        t3a = new SimpleWMClient((short) 12, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t3a.setFmt(formatter);
        t3b = new SimpleWMClient((short) 13, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t3b.setFmt(formatter);
        t3c = new SimpleWMClient((short) 14, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t3c.setFmt(formatter);
        t3d = new SimpleWMClient((short) 15, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t3d.setFmt(formatter);
        customer3_firstName = new SimpleWMClient((short) 16, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(25);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(25);
        compound.setFormatter(formatter);
        formatter = compound;
        customer3_firstName.setFmt(formatter);
        customer3_lastName = new SimpleWMClient((short) 17, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(50);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(50);
        compound.setFormatter(formatter);
        formatter = compound;
        customer3_lastName.setFmt(formatter);

        widgetModels = new WModel[] { (WModel) t1a, (WModel) t1b, (WModel) t1c, (WModel) t1d, (WModel) customer1_firstName, (WModel) customer1_lastName, (WModel) t2a, (WModel) t2b, (WModel) t2c, (WModel) t2d, (WModel) customer2_firstName, (WModel) customer2_lastName, (WModel) t3a, (WModel) t3b, (WModel) t3c, (WModel) t3d, (WModel) customer3_firstName, (WModel) customer3_lastName };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        t1a = null;
        t1b = null;
        t1c = null;
        t1d = null;
        customer1_firstName = null;
        customer1_lastName = null;
        t2a = null;
        t2b = null;
        t2c = null;
        t2d = null;
        customer2_firstName = null;
        customer2_lastName = null;
        t3a = null;
        t3b = null;
        t3c = null;
        t3d = null;
        customer3_firstName = null;
        customer3_lastName = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return Layouting.AbsoluteAttachmentClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public Layouting getTypedComponent() {
        return (Layouting) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        FormData data;
        Control[] tabOrder;
        EventAdapter adapter = new EventAdapter(this);
        final Scaler scaler = Scaler.getInstance(getComposite());
        Control lastControl;

        Composite pageCompositeabsoluteAttachmentW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        pageCompositeabsoluteAttachmentW.setLayout(layout);

        absoluteAttachment_composite_0_0W = new Group(pageCompositeabsoluteAttachmentW,SWT.NONE);
        absoluteAttachment_composite_0_0W.setText(getGenPageMessages().getString("AbsoluteAttachment.absoluteAttachment_composite_0_0W"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteAttachment_composite_0_0W.setLayout(layout);

        t1aW = new Text(absoluteAttachment_composite_0_0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1aW.setData("WIDGET_ID","t1aW");
        t1aW.addFocusListener(adapter);
        t1aW.addModifyListener(adapter);
        t1aW.addVerifyListener(adapter);

        t1bW = new Text(absoluteAttachment_composite_0_0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1bW.setData("WIDGET_ID","t1bW");
        t1bW.addFocusListener(adapter);
        t1bW.addModifyListener(adapter);
        t1bW.addVerifyListener(adapter);

        t1cW = new Text(absoluteAttachment_composite_0_0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1cW.setData("WIDGET_ID","t1cW");
        t1cW.addFocusListener(adapter);
        t1cW.addModifyListener(adapter);
        t1cW.addVerifyListener(adapter);

        t1dW = new Text(absoluteAttachment_composite_0_0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1dW.setData("WIDGET_ID","t1dW");
        t1dW.addFocusListener(adapter);
        t1dW.addModifyListener(adapter);
        t1dW.addVerifyListener(adapter);

        customer1_firstNameL = new Label(absoluteAttachment_composite_0_0W,SWT.LEFT|SWT.WRAP);
        customer1_firstNameL.setText(getGenPageMessages().getString("AbsoluteAttachment.customer1_firstNameL"));
        customer1_firstNameL.setData("WIDGET_ID","customer1_firstNameL");

        customer1_firstNameW = new Text(absoluteAttachment_composite_0_0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer1_firstNameW.setToolTipText(getGenPageMessages().getString("AbsoluteAttachment.customer1_firstNameWTip"));
        customer1_firstNameW.setData("WIDGET_ID","customer1_firstNameW");
        customer1_firstNameW.addFocusListener(adapter);
        customer1_firstNameW.addModifyListener(adapter);
        customer1_firstNameW.addVerifyListener(adapter);

        customer1_lastNameL = new Label(absoluteAttachment_composite_0_0W,SWT.LEFT|SWT.WRAP);
        customer1_lastNameL.setText(getGenPageMessages().getString("AbsoluteAttachment.customer1_lastNameL"));
        customer1_lastNameL.setData("WIDGET_ID","customer1_lastNameL");

        customer1_lastNameW = new Text(absoluteAttachment_composite_0_0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer1_lastNameW.setToolTipText(getGenPageMessages().getString("AbsoluteAttachment.customer1_lastNameWTip"));
        customer1_lastNameW.setData("WIDGET_ID","customer1_lastNameW");
        customer1_lastNameW.addFocusListener(adapter);
        customer1_lastNameW.addModifyListener(adapter);
        customer1_lastNameW.addVerifyListener(adapter);

        absoluteAttachment_composite_1_0W = new Group(pageCompositeabsoluteAttachmentW,SWT.NONE);
        absoluteAttachment_composite_1_0W.setText(getGenPageMessages().getString("AbsoluteAttachment.absoluteAttachment_composite_1_0W"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        absoluteAttachment_composite_1_0W.setLayout(layout);

        absoluteAttachment_composite_1_0_set0W = new Composite(absoluteAttachment_composite_1_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteAttachment_composite_1_0_set0W.setLayout(layout);
        absoluteAttachment_composite_1_0_set0W.setData("WIDGET_ID","absoluteAttachment_composite_1_0_set0W");

        absoluteAttachment_composite_1_0_set0_centered = new Label(absoluteAttachment_composite_1_0_set0W,SWT.LEFT);
        absoluteAttachment_composite_1_0_set0_centered.setVisible(false);
        absoluteAttachment_composite_1_0_set0_centered.setData("WIDGET_ID","absoluteAttachment_composite_1_0_set0_centered");

        t2aW = new Text(absoluteAttachment_composite_1_0_set0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t2aW.setData("WIDGET_ID","t2aW");
        t2aW.addFocusListener(adapter);
        t2aW.addModifyListener(adapter);
        t2aW.addVerifyListener(adapter);

        absoluteAttachment_composite_1_0_set1W = new Composite(absoluteAttachment_composite_1_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteAttachment_composite_1_0_set1W.setLayout(layout);
        absoluteAttachment_composite_1_0_set1W.setData("WIDGET_ID","absoluteAttachment_composite_1_0_set1W");

        absoluteAttachment_composite_1_0_set1_centered = new Label(absoluteAttachment_composite_1_0_set1W,SWT.LEFT);
        absoluteAttachment_composite_1_0_set1_centered.setVisible(false);
        absoluteAttachment_composite_1_0_set1_centered.setData("WIDGET_ID","absoluteAttachment_composite_1_0_set1_centered");

        t2bW = new Text(absoluteAttachment_composite_1_0_set1W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t2bW.setData("WIDGET_ID","t2bW");
        t2bW.addFocusListener(adapter);
        t2bW.addModifyListener(adapter);
        t2bW.addVerifyListener(adapter);

        absoluteAttachment_composite_1_0_set2W = new Composite(absoluteAttachment_composite_1_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteAttachment_composite_1_0_set2W.setLayout(layout);
        absoluteAttachment_composite_1_0_set2W.setData("WIDGET_ID","absoluteAttachment_composite_1_0_set2W");

        absoluteAttachment_composite_1_0_set2_centered = new Label(absoluteAttachment_composite_1_0_set2W,SWT.LEFT);
        absoluteAttachment_composite_1_0_set2_centered.setVisible(false);
        absoluteAttachment_composite_1_0_set2_centered.setData("WIDGET_ID","absoluteAttachment_composite_1_0_set2_centered");

        t2cW = new Text(absoluteAttachment_composite_1_0_set2W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t2cW.setData("WIDGET_ID","t2cW");
        t2cW.addFocusListener(adapter);
        t2cW.addModifyListener(adapter);
        t2cW.addVerifyListener(adapter);

        absoluteAttachment_composite_1_0_set3W = new Composite(absoluteAttachment_composite_1_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteAttachment_composite_1_0_set3W.setLayout(layout);
        absoluteAttachment_composite_1_0_set3W.setData("WIDGET_ID","absoluteAttachment_composite_1_0_set3W");

        absoluteAttachment_composite_1_0_set3_centered = new Label(absoluteAttachment_composite_1_0_set3W,SWT.LEFT);
        absoluteAttachment_composite_1_0_set3_centered.setVisible(false);
        absoluteAttachment_composite_1_0_set3_centered.setData("WIDGET_ID","absoluteAttachment_composite_1_0_set3_centered");

        t2dW = new Text(absoluteAttachment_composite_1_0_set3W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t2dW.setData("WIDGET_ID","t2dW");
        t2dW.addFocusListener(adapter);
        t2dW.addModifyListener(adapter);
        t2dW.addVerifyListener(adapter);

        absoluteAttachment_composite_1_0_set4W = new Composite(absoluteAttachment_composite_1_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteAttachment_composite_1_0_set4W.setLayout(layout);
        absoluteAttachment_composite_1_0_set4W.setData("WIDGET_ID","absoluteAttachment_composite_1_0_set4W");

        absoluteAttachment_composite_1_0_set4_centered = new Label(absoluteAttachment_composite_1_0_set4W,SWT.LEFT);
        absoluteAttachment_composite_1_0_set4_centered.setVisible(false);
        absoluteAttachment_composite_1_0_set4_centered.setData("WIDGET_ID","absoluteAttachment_composite_1_0_set4_centered");

        customer2_firstNameL = new Label(absoluteAttachment_composite_1_0_set4W,SWT.LEFT|SWT.WRAP);
        customer2_firstNameL.setText(getGenPageMessages().getString("AbsoluteAttachment.customer2_firstNameL"));
        customer2_firstNameL.setData("WIDGET_ID","customer2_firstNameL");

        customer2_firstNameW = new Text(absoluteAttachment_composite_1_0_set4W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer2_firstNameW.setToolTipText(getGenPageMessages().getString("AbsoluteAttachment.customer2_firstNameWTip"));
        customer2_firstNameW.setData("WIDGET_ID","customer2_firstNameW");
        customer2_firstNameW.addFocusListener(adapter);
        customer2_firstNameW.addModifyListener(adapter);
        customer2_firstNameW.addVerifyListener(adapter);

        absoluteAttachment_composite_1_0_set5W = new Composite(absoluteAttachment_composite_1_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteAttachment_composite_1_0_set5W.setLayout(layout);
        absoluteAttachment_composite_1_0_set5W.setData("WIDGET_ID","absoluteAttachment_composite_1_0_set5W");

        absoluteAttachment_composite_1_0_set5_centered = new Label(absoluteAttachment_composite_1_0_set5W,SWT.LEFT);
        absoluteAttachment_composite_1_0_set5_centered.setVisible(false);
        absoluteAttachment_composite_1_0_set5_centered.setData("WIDGET_ID","absoluteAttachment_composite_1_0_set5_centered");

        customer2_lastNameL = new Label(absoluteAttachment_composite_1_0_set5W,SWT.LEFT|SWT.WRAP);
        customer2_lastNameL.setText(getGenPageMessages().getString("AbsoluteAttachment.customer2_lastNameL"));
        customer2_lastNameL.setData("WIDGET_ID","customer2_lastNameL");

        customer2_lastNameW = new Text(absoluteAttachment_composite_1_0_set5W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer2_lastNameW.setToolTipText(getGenPageMessages().getString("AbsoluteAttachment.customer2_lastNameWTip"));
        customer2_lastNameW.setData("WIDGET_ID","customer2_lastNameW");
        customer2_lastNameW.addFocusListener(adapter);
        customer2_lastNameW.addModifyListener(adapter);
        customer2_lastNameW.addVerifyListener(adapter);

        absoluteAttachment_composite_2_0W = new Group(pageCompositeabsoluteAttachmentW,SWT.NONE);
        absoluteAttachment_composite_2_0W.setText(getGenPageMessages().getString("AbsoluteAttachment.absoluteAttachment_composite_2_0W"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        absoluteAttachment_composite_2_0W.setLayout(layout);

        absoluteAttachment_composite_2_0_set0W = new Composite(absoluteAttachment_composite_2_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteAttachment_composite_2_0_set0W.setLayout(layout);
        absoluteAttachment_composite_2_0_set0W.setData("WIDGET_ID","absoluteAttachment_composite_2_0_set0W");

        absoluteAttachment_composite_2_0_set0_centered = new Label(absoluteAttachment_composite_2_0_set0W,SWT.LEFT);
        absoluteAttachment_composite_2_0_set0_centered.setVisible(false);
        absoluteAttachment_composite_2_0_set0_centered.setData("WIDGET_ID","absoluteAttachment_composite_2_0_set0_centered");

        t3aW = new Text(absoluteAttachment_composite_2_0_set0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t3aW.setData("WIDGET_ID","t3aW");
        t3aW.addFocusListener(adapter);
        t3aW.addModifyListener(adapter);
        t3aW.addVerifyListener(adapter);

        absoluteAttachment_composite_2_0_set1W = new Composite(absoluteAttachment_composite_2_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteAttachment_composite_2_0_set1W.setLayout(layout);
        absoluteAttachment_composite_2_0_set1W.setData("WIDGET_ID","absoluteAttachment_composite_2_0_set1W");

        absoluteAttachment_composite_2_0_set1_centered = new Label(absoluteAttachment_composite_2_0_set1W,SWT.LEFT);
        absoluteAttachment_composite_2_0_set1_centered.setVisible(false);
        absoluteAttachment_composite_2_0_set1_centered.setData("WIDGET_ID","absoluteAttachment_composite_2_0_set1_centered");

        t3bW = new Text(absoluteAttachment_composite_2_0_set1W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t3bW.setData("WIDGET_ID","t3bW");
        t3bW.addFocusListener(adapter);
        t3bW.addModifyListener(adapter);
        t3bW.addVerifyListener(adapter);

        absoluteAttachment_composite_2_0_set2W = new Composite(absoluteAttachment_composite_2_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteAttachment_composite_2_0_set2W.setLayout(layout);
        absoluteAttachment_composite_2_0_set2W.setData("WIDGET_ID","absoluteAttachment_composite_2_0_set2W");

        absoluteAttachment_composite_2_0_set2_centered = new Label(absoluteAttachment_composite_2_0_set2W,SWT.LEFT);
        absoluteAttachment_composite_2_0_set2_centered.setVisible(false);
        absoluteAttachment_composite_2_0_set2_centered.setData("WIDGET_ID","absoluteAttachment_composite_2_0_set2_centered");

        t3cW = new Text(absoluteAttachment_composite_2_0_set2W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t3cW.setData("WIDGET_ID","t3cW");
        t3cW.addFocusListener(adapter);
        t3cW.addModifyListener(adapter);
        t3cW.addVerifyListener(adapter);

        absoluteAttachment_composite_3_0W = new Group(pageCompositeabsoluteAttachmentW,SWT.NONE);
        absoluteAttachment_composite_3_0W.setText(getGenPageMessages().getString("AbsoluteAttachment.absoluteAttachment_composite_3_0W"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        absoluteAttachment_composite_3_0W.setLayout(layout);

        absoluteAttachment_composite_3_0_set0W = new Composite(absoluteAttachment_composite_3_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteAttachment_composite_3_0_set0W.setLayout(layout);
        absoluteAttachment_composite_3_0_set0W.setData("WIDGET_ID","absoluteAttachment_composite_3_0_set0W");

        absoluteAttachment_composite_3_0_set0_centered = new Label(absoluteAttachment_composite_3_0_set0W,SWT.LEFT);
        absoluteAttachment_composite_3_0_set0_centered.setVisible(false);
        absoluteAttachment_composite_3_0_set0_centered.setData("WIDGET_ID","absoluteAttachment_composite_3_0_set0_centered");

        t3dW = new Text(absoluteAttachment_composite_3_0_set0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t3dW.setData("WIDGET_ID","t3dW");
        t3dW.addFocusListener(adapter);
        t3dW.addModifyListener(adapter);
        t3dW.addVerifyListener(adapter);

        absoluteAttachment_composite_4_0W = new Group(pageCompositeabsoluteAttachmentW,SWT.NONE);
        absoluteAttachment_composite_4_0W.setText(getGenPageMessages().getString("AbsoluteAttachment.absoluteAttachment_composite_4_0W"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        absoluteAttachment_composite_4_0W.setLayout(layout);

        absoluteAttachment_composite_4_0_set0W = new Composite(absoluteAttachment_composite_4_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteAttachment_composite_4_0_set0W.setLayout(layout);
        absoluteAttachment_composite_4_0_set0W.setData("WIDGET_ID","absoluteAttachment_composite_4_0_set0W");

        absoluteAttachment_composite_4_0_set0_centered = new Label(absoluteAttachment_composite_4_0_set0W,SWT.LEFT);
        absoluteAttachment_composite_4_0_set0_centered.setVisible(false);
        absoluteAttachment_composite_4_0_set0_centered.setData("WIDGET_ID","absoluteAttachment_composite_4_0_set0_centered");

        customer3_firstNameL = new Label(absoluteAttachment_composite_4_0_set0W,SWT.LEFT|SWT.WRAP);
        customer3_firstNameL.setText(getGenPageMessages().getString("AbsoluteAttachment.customer3_firstNameL"));
        customer3_firstNameL.setData("WIDGET_ID","customer3_firstNameL");

        customer3_firstNameW = new Text(absoluteAttachment_composite_4_0_set0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer3_firstNameW.setToolTipText(getGenPageMessages().getString("AbsoluteAttachment.customer3_firstNameWTip"));
        customer3_firstNameW.setData("WIDGET_ID","customer3_firstNameW");
        customer3_firstNameW.addFocusListener(adapter);
        customer3_firstNameW.addModifyListener(adapter);
        customer3_firstNameW.addVerifyListener(adapter);

        absoluteAttachment_composite_4_0_set1W = new Composite(absoluteAttachment_composite_4_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteAttachment_composite_4_0_set1W.setLayout(layout);
        absoluteAttachment_composite_4_0_set1W.setData("WIDGET_ID","absoluteAttachment_composite_4_0_set1W");

        absoluteAttachment_composite_4_0_set1_centered = new Label(absoluteAttachment_composite_4_0_set1W,SWT.LEFT);
        absoluteAttachment_composite_4_0_set1_centered.setVisible(false);
        absoluteAttachment_composite_4_0_set1_centered.setData("WIDGET_ID","absoluteAttachment_composite_4_0_set1_centered");

        customer3_lastNameL = new Label(absoluteAttachment_composite_4_0_set1W,SWT.LEFT|SWT.WRAP);
        customer3_lastNameL.setText(getGenPageMessages().getString("AbsoluteAttachment.customer3_lastNameL"));
        customer3_lastNameL.setData("WIDGET_ID","customer3_lastNameL");

        customer3_lastNameW = new Text(absoluteAttachment_composite_4_0_set1W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer3_lastNameW.setToolTipText(getGenPageMessages().getString("AbsoluteAttachment.customer3_lastNameWTip"));
        customer3_lastNameW.setData("WIDGET_ID","customer3_lastNameW");
        customer3_lastNameW.addFocusListener(adapter);
        customer3_lastNameW.addModifyListener(adapter);
        customer3_lastNameW.addVerifyListener(adapter);

        widgets = new Control[] { absoluteAttachment_composite_0_0W, t1aW, t1bW, t1cW, t1dW, customer1_firstNameL, customer1_firstNameW, customer1_lastNameL, customer1_lastNameW, absoluteAttachment_composite_1_0W, absoluteAttachment_composite_1_0_set0W, absoluteAttachment_composite_1_0_set0_centered, t2aW, absoluteAttachment_composite_1_0_set1W, absoluteAttachment_composite_1_0_set1_centered, t2bW, absoluteAttachment_composite_1_0_set2W, absoluteAttachment_composite_1_0_set2_centered, t2cW, absoluteAttachment_composite_1_0_set3W, absoluteAttachment_composite_1_0_set3_centered, t2dW, absoluteAttachment_composite_1_0_set4W, absoluteAttachment_composite_1_0_set4_centered, customer2_firstNameL, customer2_firstNameW, absoluteAttachment_composite_1_0_set5W, absoluteAttachment_composite_1_0_set5_centered, customer2_lastNameL, customer2_lastNameW, absoluteAttachment_composite_2_0W, absoluteAttachment_composite_2_0_set0W, absoluteAttachment_composite_2_0_set0_centered, t3aW, absoluteAttachment_composite_2_0_set1W, absoluteAttachment_composite_2_0_set1_centered, t3bW, absoluteAttachment_composite_2_0_set2W, absoluteAttachment_composite_2_0_set2_centered, t3cW, absoluteAttachment_composite_3_0W, absoluteAttachment_composite_3_0_set0W, absoluteAttachment_composite_3_0_set0_centered, t3dW, absoluteAttachment_composite_4_0W, absoluteAttachment_composite_4_0_set0W, absoluteAttachment_composite_4_0_set0_centered, customer3_firstNameL, customer3_firstNameW, absoluteAttachment_composite_4_0_set1W, absoluteAttachment_composite_4_0_set1_centered, customer3_lastNameL, customer3_lastNameW };

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(50,100,scaler.convertXToCurrent(-2));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_0_0W.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(200));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(10));
        t1aW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(200));
        data.top = new FormAttachment(t1aW,scaler.convertYToCurrent(0),SWT.BOTTOM);
        t1bW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(180);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.top = new FormAttachment(t1bW,scaler.convertYToCurrent(0),SWT.BOTTOM);
        t1cW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(200));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(t1cW,scaler.convertYToCurrent(0),SWT.BOTTOM);
        t1dW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(200));
        data.top = new FormAttachment(t1dW,scaler.convertYToCurrent(0),SWT.BOTTOM);
        customer1_firstNameL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(200));
        data.top = new FormAttachment(customer1_firstNameL,scaler.convertYToCurrent(0),SWT.BOTTOM);
        customer1_firstNameW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.top = new FormAttachment(customer1_firstNameW,scaler.convertYToCurrent(0),SWT.BOTTOM);
        customer1_lastNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(180);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.top = new FormAttachment(customer1_lastNameL,scaler.convertYToCurrent(0),SWT.BOTTOM);
        customer1_lastNameW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(50,100,scaler.convertXToCurrent(2));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(absoluteAttachment_composite_0_0W,scaler.convertYToCurrent(0),SWT.BOTTOM);
        absoluteAttachment_composite_1_0W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_1_0_set0W.setLayoutData(data);
        lastControl=absoluteAttachment_composite_1_0_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteAttachment_composite_1_0_set1W.setLayoutData(data);
        lastControl=absoluteAttachment_composite_1_0_set1W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteAttachment_composite_1_0_set2W.setLayoutData(data);
        lastControl=absoluteAttachment_composite_1_0_set2W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteAttachment_composite_1_0_set3W.setLayoutData(data);
        lastControl=absoluteAttachment_composite_1_0_set3W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteAttachment_composite_1_0_set4W.setLayoutData(data);
        lastControl=absoluteAttachment_composite_1_0_set4W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteAttachment_composite_1_0_set5W.setLayoutData(data);
        lastControl=absoluteAttachment_composite_1_0_set5W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_1_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(200));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(10));
        t2aW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_1_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(200));
        data.top = new FormAttachment(absoluteAttachment_composite_1_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t2bW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_1_0_set2_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(180);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.top = new FormAttachment(absoluteAttachment_composite_1_0_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t2cW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_1_0_set3_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(360);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(200));
        data.top = new FormAttachment(absoluteAttachment_composite_1_0_set3_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t2dW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_1_0_set4_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.top = new FormAttachment(absoluteAttachment_composite_1_0_set4_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer2_firstNameL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(customer2_firstNameL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(200));
        data.top = new FormAttachment(absoluteAttachment_composite_1_0_set4_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer2_firstNameW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_1_0_set5_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.top = new FormAttachment(absoluteAttachment_composite_1_0_set5_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer2_lastNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(180);
        data.left = new FormAttachment(customer2_lastNameL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(absoluteAttachment_composite_1_0_set5_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer2_lastNameW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(absoluteAttachment_composite_1_0W,scaler.convertYToCurrent(0),SWT.BOTTOM);
        absoluteAttachment_composite_2_0W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
            data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_2_0_set0W.setLayoutData(data);
        lastControl=absoluteAttachment_composite_2_0_set0W;

        data = new FormData();
        if(lastControl!=null) {
            data.left = new FormAttachment(lastControl,scaler.convertXToCurrent(3),SWT.RIGHT);
        } else {
            data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        }
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_2_0_set1W.setLayoutData(data);
        lastControl=absoluteAttachment_composite_2_0_set1W;

        data = new FormData();
        if(lastControl!=null) {
            data.left = new FormAttachment(lastControl,scaler.convertXToCurrent(3),SWT.RIGHT);
        } else {
            data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        }
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_2_0_set2W.setLayoutData(data);
        lastControl=absoluteAttachment_composite_2_0_set2W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_2_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(200));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(10));
        t3aW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_2_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(200));
        data.top = new FormAttachment(absoluteAttachment_composite_2_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t3bW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_2_0_set2_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(180);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.top = new FormAttachment(absoluteAttachment_composite_2_0_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t3cW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(absoluteAttachment_composite_2_0W,scaler.convertYToCurrent(0),SWT.BOTTOM);
        absoluteAttachment_composite_3_0W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
            data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_3_0_set0W.setLayoutData(data);
        lastControl=absoluteAttachment_composite_3_0_set0W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_3_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(360);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(200));
        data.top = new FormAttachment(absoluteAttachment_composite_3_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t3dW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(absoluteAttachment_composite_3_0W,scaler.convertYToCurrent(0),SWT.BOTTOM);
        absoluteAttachment_composite_4_0W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
            data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_4_0_set0W.setLayoutData(data);
        lastControl=absoluteAttachment_composite_4_0_set0W;

        data = new FormData();
        if(lastControl!=null) {
            data.left = new FormAttachment(lastControl,scaler.convertXToCurrent(3),SWT.RIGHT);
        } else {
            data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        }
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_4_0_set1W.setLayoutData(data);
        lastControl=absoluteAttachment_composite_4_0_set1W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_4_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.top = new FormAttachment(absoluteAttachment_composite_4_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer3_firstNameL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(customer3_firstNameL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(200));
        data.top = new FormAttachment(absoluteAttachment_composite_4_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer3_firstNameW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteAttachment_composite_4_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(10));
        data.top = new FormAttachment(absoluteAttachment_composite_4_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer3_lastNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(180);
        data.left = new FormAttachment(customer3_lastNameL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(absoluteAttachment_composite_4_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer3_lastNameW.setLayoutData(data);


        tabOrder = new Control[5];
        tabOrder[0] = absoluteAttachment_composite_0_0W;
        tabOrder[1] = absoluteAttachment_composite_1_0W;
        tabOrder[2] = absoluteAttachment_composite_2_0W;
        tabOrder[3] = absoluteAttachment_composite_3_0W;
        tabOrder[4] = absoluteAttachment_composite_4_0W;
        pageCompositeabsoluteAttachmentW.setTabList(tabOrder);
        tabOrder = new Control[6];
        tabOrder[0] = t1aW;
        tabOrder[1] = t1bW;
        tabOrder[2] = t1cW;
        tabOrder[3] = t1dW;
        tabOrder[4] = customer1_firstNameW;
        tabOrder[5] = customer1_lastNameW;
        absoluteAttachment_composite_0_0W.setTabList(tabOrder);
        tabOrder = new Control[6];
        tabOrder[0] = absoluteAttachment_composite_1_0_set0W;
        tabOrder[1] = absoluteAttachment_composite_1_0_set1W;
        tabOrder[2] = absoluteAttachment_composite_1_0_set2W;
        tabOrder[3] = absoluteAttachment_composite_1_0_set3W;
        tabOrder[4] = absoluteAttachment_composite_1_0_set4W;
        tabOrder[5] = absoluteAttachment_composite_1_0_set5W;
        absoluteAttachment_composite_1_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t2aW;
        absoluteAttachment_composite_1_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t2bW;
        absoluteAttachment_composite_1_0_set1W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t2cW;
        absoluteAttachment_composite_1_0_set2W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t2dW;
        absoluteAttachment_composite_1_0_set3W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer2_firstNameW;
        absoluteAttachment_composite_1_0_set4W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer2_lastNameW;
        absoluteAttachment_composite_1_0_set5W.setTabList(tabOrder);
        tabOrder = new Control[3];
        tabOrder[0] = absoluteAttachment_composite_2_0_set0W;
        tabOrder[1] = absoluteAttachment_composite_2_0_set1W;
        tabOrder[2] = absoluteAttachment_composite_2_0_set2W;
        absoluteAttachment_composite_2_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t3aW;
        absoluteAttachment_composite_2_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t3bW;
        absoluteAttachment_composite_2_0_set1W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t3cW;
        absoluteAttachment_composite_2_0_set2W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = absoluteAttachment_composite_3_0_set0W;
        absoluteAttachment_composite_3_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t3dW;
        absoluteAttachment_composite_3_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[2];
        tabOrder[0] = absoluteAttachment_composite_4_0_set0W;
        tabOrder[1] = absoluteAttachment_composite_4_0_set1W;
        absoluteAttachment_composite_4_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer3_firstNameW;
        absoluteAttachment_composite_4_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer3_lastNameW;
        absoluteAttachment_composite_4_0_set1W.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        absoluteAttachment_composite_0_0W = null;
        t1aW = null;
        t1bW = null;
        t1cW = null;
        t1dW = null;
        customer1_firstNameL = null;
        customer1_firstNameW = null;
        customer1_lastNameL = null;
        customer1_lastNameW = null;
        absoluteAttachment_composite_1_0W = null;
        absoluteAttachment_composite_1_0_set0W = null;
        absoluteAttachment_composite_1_0_set0_centered = null;
        t2aW = null;
        absoluteAttachment_composite_1_0_set1W = null;
        absoluteAttachment_composite_1_0_set1_centered = null;
        t2bW = null;
        absoluteAttachment_composite_1_0_set2W = null;
        absoluteAttachment_composite_1_0_set2_centered = null;
        t2cW = null;
        absoluteAttachment_composite_1_0_set3W = null;
        absoluteAttachment_composite_1_0_set3_centered = null;
        t2dW = null;
        absoluteAttachment_composite_1_0_set4W = null;
        absoluteAttachment_composite_1_0_set4_centered = null;
        customer2_firstNameL = null;
        customer2_firstNameW = null;
        absoluteAttachment_composite_1_0_set5W = null;
        absoluteAttachment_composite_1_0_set5_centered = null;
        customer2_lastNameL = null;
        customer2_lastNameW = null;
        absoluteAttachment_composite_2_0W = null;
        absoluteAttachment_composite_2_0_set0W = null;
        absoluteAttachment_composite_2_0_set0_centered = null;
        t3aW = null;
        absoluteAttachment_composite_2_0_set1W = null;
        absoluteAttachment_composite_2_0_set1_centered = null;
        t3bW = null;
        absoluteAttachment_composite_2_0_set2W = null;
        absoluteAttachment_composite_2_0_set2_centered = null;
        t3cW = null;
        absoluteAttachment_composite_3_0W = null;
        absoluteAttachment_composite_3_0_set0W = null;
        absoluteAttachment_composite_3_0_set0_centered = null;
        t3dW = null;
        absoluteAttachment_composite_4_0W = null;
        absoluteAttachment_composite_4_0_set0W = null;
        absoluteAttachment_composite_4_0_set0_centered = null;
        customer3_firstNameL = null;
        customer3_firstNameW = null;
        absoluteAttachment_composite_4_0_set1W = null;
        absoluteAttachment_composite_4_0_set1_centered = null;
        customer3_lastNameL = null;
        customer3_lastNameW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        t1aW.setData(t1a.getUIDelegate());
        t1a.getUIDelegate().attachUI(t1aW,null);
        t1bW.setData(t1b.getUIDelegate());
        t1b.getUIDelegate().attachUI(t1bW,null);
        t1cW.setData(t1c.getUIDelegate());
        t1c.getUIDelegate().attachUI(t1cW,null);
        t1dW.setData(t1d.getUIDelegate());
        t1d.getUIDelegate().attachUI(t1dW,null);
        customer1_firstNameW.setData(customer1_firstName.getUIDelegate());
        customer1_firstName.getUIDelegate().attachUI(customer1_firstNameW,customer1_firstNameL);
        customer1_lastNameW.setData(customer1_lastName.getUIDelegate());
        customer1_lastName.getUIDelegate().attachUI(customer1_lastNameW,customer1_lastNameL);
        t2aW.setData(t2a.getUIDelegate());
        t2a.getUIDelegate().attachUI(t2aW,null);
        t2bW.setData(t2b.getUIDelegate());
        t2b.getUIDelegate().attachUI(t2bW,null);
        t2cW.setData(t2c.getUIDelegate());
        t2c.getUIDelegate().attachUI(t2cW,null);
        t2dW.setData(t2d.getUIDelegate());
        t2d.getUIDelegate().attachUI(t2dW,null);
        customer2_firstNameW.setData(customer2_firstName.getUIDelegate());
        customer2_firstName.getUIDelegate().attachUI(customer2_firstNameW,customer2_firstNameL);
        customer2_lastNameW.setData(customer2_lastName.getUIDelegate());
        customer2_lastName.getUIDelegate().attachUI(customer2_lastNameW,customer2_lastNameL);
        t3aW.setData(t3a.getUIDelegate());
        t3a.getUIDelegate().attachUI(t3aW,null);
        t3bW.setData(t3b.getUIDelegate());
        t3b.getUIDelegate().attachUI(t3bW,null);
        t3cW.setData(t3c.getUIDelegate());
        t3c.getUIDelegate().attachUI(t3cW,null);
        t3dW.setData(t3d.getUIDelegate());
        t3d.getUIDelegate().attachUI(t3dW,null);
        customer3_firstNameW.setData(customer3_firstName.getUIDelegate());
        customer3_firstName.getUIDelegate().attachUI(customer3_firstNameW,customer3_firstNameL);
        customer3_lastNameW.setData(customer3_lastName.getUIDelegate());
        customer3_lastName.getUIDelegate().attachUI(customer3_lastNameW,customer3_lastNameL);
    }

    /**
     * Enables or disables Widgets according to the current state of the page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called immediately after {@link #determineState()}.
     */
    public void stateChanged() {

        customer1_firstName.setMandatory(true);
        customer1_lastName.setMandatory(true);
        customer2_firstName.setMandatory(true);
        customer2_lastName.setMandatory(true);
        customer3_firstName.setMandatory(true);
        customer3_lastName.setMandatory(true);
    }

    /**
     * This method will be called every time the AbsoluteAttachment becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
    }

    /**
     * Creates the coresponding TabItem
     */
    protected TabItem createTabItem(TabFolder LayoutingPage_tabfolder_0_0_0_0W,int index) {
        TabItem absoluteAttachmentW = new TabItem (LayoutingPage_tabfolder_0_0_0_0W, SWT.NULL, index);
        absoluteAttachmentW.setText(getGenPageMessages().getString("AbsoluteAttachment"));
        absoluteAttachmentW.setControl(getComposite());
        absoluteAttachmentW.setData(this);

        return absoluteAttachmentW;
    }
}
