package org.openxma.dsl.reference.xma.customeredit.server;

import org.openxma.dsl.reference.dto.CustomerView;
import org.openxma.dsl.reference.service.CustomerService;
import org.springframework.beans.factory.annotation.Autowired;

import at.spardat.xma.component.ComponentServer;
import at.spardat.xma.rpc.RemoteCall;
import at.spardat.xma.rpc.RemoteReply;

/**
 *
 * @author clay
 */
public class CustomerSearchForm extends CustomerSearchFormGen {
	@Autowired
	private CustomerService customerService;

    /**
     * Constructs the CustomerSearchForm.
     *
     * @param component the component this page belongs to
     */
    public CustomerSearchForm(ComponentServer component) {
        super(component);
    }

	
	@Override
	public void findCustomer(RemoteCall call, RemoteReply reply) {
		String firstName = this.customer_firstName.getEncodedValue();
		String lastName  = this.customer_lastName.getEncodedValue();
		getTypedComponent().setCustomers(this.customerService.findAllByFirstNameAndLastName(firstName,lastName));
		this.customerTableFill();
	}

	@Override
	public void selectCustomer(RemoteCall call, RemoteReply reply) {
		String selected = this.customerTable.getSelected();
		CustomerView customer = customerService.loadCustomerView(selected);
		getTypedComponent().setCustomer(customer);
		getTypedComponent().setSelectedCustomerId(customer.getOid());
		getTypedComponent().setSelectedCustomerFirstName(customer.getFirstName());
		getTypedComponent().setSelectedCustomerLastName(customer.getLastName());
	}

}
